# Hunter's Dead Bomb Addon
#  
# Install instructions:
#       1. Install Mattie's EventScripts 2.0 plugin:
#           http://mattie.info/cs/
#
#       2. Copy and upload this script to:
#           <gamedir>/addons/eventscripts/dead_bomb/
#
#       3. Add the following line somewhere in autoexec.cfg:
#           es_load dead_bomb
#
################################################################################
#import EventScripts
import es
#import Libraries
import gamethread
import playerlib
import random
#import Psyco Compiler
import psyco
psyco.full()

# Addon Information
info = es.AddonInfo()
info.name = "Dead Bomb"
info.version = "2.0.0"
info.author = "Hunter"
info.url = "http://addons.eventscripts.com/addons/user/289"
info.description = "Creates bombs at the place a player died"
info.basename = "dead_bomb"

hunter_dead_bomb_ver    = info.version
hunter_dead_bomb_text   = 'Hunters '+info.name+', www.sourceplugins.de, '+info.version+', ES 2.0.0.247+ (Python Version)'

# Server Variables
dead_bomb_radius        = es.ServerVar('dead_bomb_radius', '500', 'Radius of the explosion? (in-game units)')
dead_bomb_damage        = es.ServerVar('dead_bomb_damage', '90', 'Damage of the explosion?')

def load():
    public = es.ServerVar('hu_db', info.version, info.name)
    public.makepublic()

    es.log(hunter_dead_bomb_text)
    es.msg('#multi', '#green[DeadBomb] #defaultLoaded')
    
def unload():
    es.msg('#multi', '#green[DeadBomb] #defaultUnloaded') 

def es_map_start(event_var):
    es.stringtable('downloadables', 'models/roller_spikes.mdl')
    es.precachemodel('roller_spikes.mdl')

def es_client_command(event_var):
    if (str(event_var['command']) == '!hunter_dead_bomb_ver') or (str(event_var['command']) == '!hunter_all_ver'):
        es.cexec(int(event_var['userid']), 'echo '+hunter_dead_bomb_text)

def player_activate(event_var):
    gamethread.delayed(30, es.cexec, (int(event_var['userid']), 'echo '+hunter_dead_bomb_text))

def player_death(event_var):
    userid = int(event_var['userid'])
    attackerid = int(event_var['attacker'])
    if (userid > 0) and (attackerid > 0):
        player = playerlib.getPlayer(userid)
        playerpos = player.get('location')
        es.precachemodel('roller_spikes.mdl')
        es.prop_dynamic_create(attackerid, 'roller_spikes.mdl')
        gamethread.delayed(0.1, _handle_bomb, (userid, playerpos))

def _handle_bomb(userid, playerpos):
    bombindex = int(es.server_var['eventscripts_lastgive'])
    bombname = 'dead_bomb_'+str(userid)+'_'+str(random.randint(1,100))
    if bombindex > 0:
        originpos = str(playerpos[0])+' '+str(playerpos[1])+' '+str(playerpos[2])
        vectorpos = originpos.replace(' ', ',')
        es.ServerCommand('setentname '+str(bombindex)+' "'+bombname+'"')
        es.ServerCommand('es_xfire '+str(userid)+' '+bombname+' addoutput "origin '+originpos+'"')
        es.ServerCommand('es_xfire '+str(userid)+' '+bombname+' addoutput "exploderadius '+str(dead_bomb_radius)+'"')
        es.ServerCommand('es_xfire '+str(userid)+' '+bombname+' addoutput "explodedamage '+str(dead_bomb_damage)+'"')
        es.effect('sparks', vectorpos, '1', '1', '0,0,0')
        gamethread.delayed(1, es.effect, ('sparks', vectorpos, '2', '1', '0,0,0'))
        gamethread.delayed(2, es.effect, ('sparks', vectorpos, '2', '2', '0,0,0'))
        gamethread.delayed(3, es.effect, ('sparks', vectorpos, '3', '2', '0,0,0'))
        gamethread.delayed(4, es.effect, ('sparks', vectorpos, '3', '3', '0,0,0'))
        gamethread.delayed(4, es.effect, ('smoke', vectorpos, 'smoke', '200', '7'))
        gamethread.delayed(4, es.ServerCommand, ('es_xfire '+str(userid)+' '+bombname+' break'))
